<?php

function SetupStyle()
{
	print "  <STYLE TYPE=\"text/css\">\n";
	print "  //<!-- \n";
	print "  body \n";
	print "  {  \n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 10pt;\n";
	print "  }\n";
	print "\n";
	print "  th   \n";
	print "  {  \n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 10pt; \n";
	print "    font-weight: bold;\n";
	print "    background-color: #D3DCE3;\n";
	print "  }\n";
	print "\n";
	print "  td\n";
	print "  {\n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 9pt;\n";
	print "  }\n";
	print " \n";
	print "  form\n";
	print "  {\n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 10pt;\n";
	print "  }\n";
	print "\n";
	print "  h1\n";
	print "  {\n";
	print "    font-family: Verdana, Arial, Helvetica, sans-serif;\n";
	print "    font-size: 16pt;\n";
	print "    font-weight: bold;\n";
	print "  }\n";
	print "\n";
	print "  A:link\n";
	print "  {\n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 10pt;\n";
	print "    text-decoration: none;\n";
	print "    color: blue;\n";
	print "  }\n";
	print "  A:visited\n";
	print "  {\n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 10pt;\n";
	print "    text-decoration: none;\n";
	print "    color: blue;\n";
	print "  }\n";
	print "  A:hover\n";
	print "  {\n";
	print "    font-family: Arial, Helvetica, sans-serif;\n";
	print "    font-size: 10pt;\n";
	print "    text-decoration: underline;\n";
	print "    color: red;\n";
	print "  }\n";
	print "\n";
	print "  A:link.nav\n";
	print "  {\n";
	print "    font-family: Verdana, Arial, Helvetica, sans-serif;\n";
	print "    color: #000000;\n";
	print "  }\n";
	print "\n";
	print "  A:visited.nav\n";
	print "  {\n";
	print "    font-family: Verdana, Arial, Helvetica, sans-serif;\n";
	print "     color: #000000;\n";
	print "  }\n";
	print "\n";
	print "  A:hover.nav\n";
	print "  {\n";
	print "    font-family: Verdana, Arial, Helvetica, sans-serif;\n";
	print "     color: red;\n";
	print "  }\n";
	print "\n";
	print "  .nav\n";
	print "  {\n";
	print "    font-family: Verdana, Arial, Helvetica, sans-serif;\n";
	print "    color: #000000;\n";
	print "  }\n";
	print "\n";
	print "  //-->\n";
	print "  </STYLE>\n";

}

function print_headers($ver,$ref_url,$refresh) {

	if($refresh > 0) {
		$request_uri = preg_replace("/\/$/","",$_SERVER["REQUEST_URI"]);
		$_SESSION["ref_page"] = $request_uri;
	} 
	

	header('Date: '.gmdate('D, d M Y H:i:s \G\M\T', time()));
	header('Last-Modified: '.gmdate('D, d M Y H:i:s \G\M\T', time()));
#	header('Expires: '.gmdate('D, d M Y H:i:s \G\M\T', time() + $refresh));
	header('Refresh: '.$refresh.'; url='.$ref_url);
	header("Cache-Control: no-cache, must-revalidate");
	header("Pragma: no-cache");

	$script_array = pathinfo($_SERVER["SCRIPT_NAME"]);
	$RTG_PNG = $script_array["dirname"]."/rtg.png";

	SetupStyle();
	print "<HTML>\n<!-- RTG Version $VERSION -->\n<HEAD>\n";
	print "</HEAD>\n";
	print "<!-- rtgplot == ".$_SESSION["rtgplot"]." - ref_page == ".$_SESSION["ref_page"]." pixel_width == ".$_SESSION["pixel_width"]." graph_date == ".$_SESSION["graph_date"]." -->\n";
	print "<BODY BGCOLOR=\"ffffff\">\n";
	print "<TABLE WIDTH=100% CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
	print "<TR><TD ALIGN=LEFT WIDTH=90%>\n";
	print "<A HREF=\"http://rtg.sourceforge.net\" ALT=\"[RTG Home Page]\">\n";
	print "<IMG SRC=\"$RTG_PNG\" BORDER=\"0\"></A>\n";
	print "</TD><TD ALIGN=RIGHT><TABLE CELLPADDING=2 CELLSPACING=0 BORDERCOLOR=\"CCCCCC\" BORDER=1><TR>\n";
	foreach(get_dates() as $s_date) {
		if($s_date == $_SESSION["graph_date"]) {
			$bgcolor = "BGCOLOR=\"99FFFF\"";
		} else { $bgcolor = ""; }
		print "<TD $bgcolor><A HREF=\"".$_SERVER["SCRIPT_NAME"]."/date/$s_date\"><FONT SIZE=1 COLOR=\"blue\">$s_date</FONT></A></TD>\n";
	}
	print "</TR></TABLE></TD>\n";
	print "</TD><TD ALIGN=RIGHT><TABLE CELLPADDING=2 CELLSPACING=0 BORDERCOLOR=\"CCCCCC\" BORDER=1><TR>\n";
	foreach(get_screen_sizes() as $s_size) {
		list($s_wide,$s_high) = split("x",$s_size);
		if($s_wide == $_SESSION["pixel_width"]) {
			$bgcolor = "BGCOLOR=\"99FFFF\"";
		} else { $bgcolor = ""; }
		print "<TD $bgcolor><A HREF=\"".$_SERVER["SCRIPT_NAME"]."/size/$s_wide\"><FONT SIZE=1 COLOR=\"blue\">$s_size</FONT></A></TD>\n";
	}
	print "</TR></TABLE></TD>\n";
	print "</TR><TR><TD ALIGN=RIGHT COLSPAN=3>".date('r')."</TD></TR></TABLE>\n";

}

#
# return a nice table of info on the host
#
function print_host_header($header_array) {
	$header_string = "";
	$bgc1 = "999999";
	$bgc2 = "CCCCCC";

	if(isset($header_array["Speed:"])) {
		if($header_array["Speed:"] >= 1000 * 1000 * 1000) {
			$speed = sprintf("%dGbps",$header_array["Speed:"] / (1000 * 1000 * 1000));
		} elseif($header_array["Speed:"] >= 1000 * 1000) {
			$speed = sprintf("%dMbps",$header_array["Speed:"] / (1000 * 1000));
		} elseif($header_array["Speed:"] >= 1000) {
			$speed = sprintf("%dKbps",$header_array["Speed:"] / 1000);
		} else { 
			$speed = sprintf("%dbps",$header_array["Speed:"]);
		}

		$header_array["Speed:"] = $speed;
	}

	$header_string .= "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>\n";
	foreach($header_array as $k => $v) {
		$header_string .= "<TR><TD ALIGN=LEFT BGCOLOR=\"$bgc1\" WIDTH=\"5%\"><B>$k</B></TD>\n";
		$header_string .= "<TD ALIGN=LEFT BGCOLOR=\"$bgc2\">$v</TD></TR>\n";
	}
	$header_string .= "</TABLE>\n";

	return $header_string;
}

function get_graph_size($max_cols) {
	# the size of the graphs
	$yplot = 100;
	$max_pixel_width = $_SESSION["pixel_width"] - 70;

	# default padding of image size
	# based on rtgplot.h
	$def_table_pad_l = 50;
	$def_table_pad_r = 20;

	$pixel_pad = ($def_table_pad_l + $def_table_pad_r) * $max_cols;
	$xplot = sprintf("%d",($max_pixel_width - $pixel_pad) / $max_cols);

	return array($xplot,$yplot);
}

# return list of screen sizes
function get_screen_sizes() {
	$screen_sizes = array("800x600","1024x768","1152x900","1280x1024","1600x1400");
	return $screen_sizes;

}

# return list of possible date formats
function get_dates() {
	$date_list = array("4h","8h","12h","1d","1w","1m","1y");
	return $date_list;
}

#
# returns a prettier version of our date
#
function get_date_pretty($graph_len) {

	$time_string = "";
	$time_format = substr($graph_len,-1);
        $time_num = substr($graph_len,0,-1);
        if($time_format == "h") {
		$time_string = "$time_num Hour";
	} elseif($time_format== "d") {
		$time_string = "$time_num Day";
	} elseif($time_format == "w") {
		$time_string = "$time_num Week";
	} elseif($time_format == "m") {
		$time_string = "$time_num Month";
	} elseif($time_format == "y") {
		$time_string = "$time_num Year";
	}
	else {
		$time_string= "$time_num Second";
	}

	if($time_num > 1) { $time_string .= "s"; }
	
	return $time_string;
}

 # Query wrapper
function query($dbc, $q) {
	if ($pgsql)
		return (pg_query($dbc, $q));
	else
		return (mysql_query($q, $dbc));
}

# Fetch wrapper
function fetch_object($r) {
	if ($pgsql)
		return (pg_fetch_object($r));
	else
		return (mysql_fetch_object($r));
}

function fetch_array($r) {
	if($pgsql)                                                                                                                    
		return (pg_fetch_array($r));                                                                                                 
	else
		return (mysql_fetch_array($r));
}

# Num rows wrapper
function num_rows($r) {
	if ($pgsql)
		return (pg_num_rows($r));
	else
		return (mysql_num_rows($r));
}


function printheader($title) {
  # Generate Title 
  echo "<TITLE>RTG: $title</TITLE>\n";
  print "<meta HTTP-EQUIV=\"Generator\" CONTENT=\"RTG $VERSION\">\n";
  print "<meta HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n";

#  print "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"300\">\n";
#  print "<meta HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
#  print "<meta HTTP-EQUIV=\"Cache-Control\" CONTENT=\"no-cache\">\n";
#  print "<meta HTTP-EQUIV=\"Expires\" CONTENT=\"".gmdate('D, d M Y H:i:s \G\M\T', time() + 300)."\">\n";

}

function listhosts($dbc) {
	$max_rows = 4;
	printheader("Listing hosts");
	$selectQuery="SELECT rid, name FROM router ORDER BY name";
	$selectResult=query($dbc,$selectQuery);
	if (num_rows($selectResult) <= 0)
		print "<BR>No Routers Found.<BR>\n";
	else {
		$column = 0;
		print "<TABLE BORDER=0 WIDTH=100%>\n";
		while ($selectRow=fetch_object($selectResult)){
			if($column == 0) {
				print "<TR>\n";
			}
			$request_uri = preg_replace("/\/$/","",$_SERVER["REQUEST_URI"]);
			print "<TD><A HREF=\"".$request_uri."/$selectRow->name\">";
			print "$selectRow->name</A></TD>\n";
			$column++;
			if($column >= $max_rows) {
				print "</TR>\n";
				$column = 0;
			} 
		}
		print "</TABLE>\n";
	}

}

function liststats($dbc) {
	printheader("stat list");
	print "Listing stats\n";
}

function stathosts($dbc,$stat) {
	printheader("hosts with $stat");
	print "displaying hosts with [$stat]\n";
}

#
#
#
function displaystats($dbc,$stat,$host,$id) {
	printheader("$host:$stat:$id");
	$rid = getrid($dbc,$host);
	$max_cols = 2;

	list($xplot,$yplot) = get_graph_size($max_cols);

	$selectQuery="SELECT class from options_table WHERE graphname=\"$stat\"";
	$selectResult=query($dbc,$selectQuery);
	$selectRow=fetch_object($selectResult);
	$class=$selectRow->class;
	
	$selectQuery="SELECT id, name, description, speed FROM interface WHERE id=$id";
	$selectResult=query($dbc,$selectQuery);
	$selectRow=fetch_object($selectResult);

	$header_array["Host:"] = $host;
	$header_array["sysDescr:"] = getsysDescr($dbc,$host);
	$header_array["Interface:"] = $selectRow->description;
	$header_array["Description:"] = $selectRow->name;
	if(preg_match('/network$/',$class)) {
		$header_array["Speed:"] = $selectRow->speed;
	}

	$host_header = print_host_header($header_array);
	
	
	$et = time();
	$table_header = array();
	$table_data = array();
	$col_num = 0;
	foreach(array("8h","24h","7d","1m","1y") as $graph_date) {
		$bt = $et - conv_our_time($graph_date);
		$graph_tag=create_img_tag($dbc,$stat,$rid,$id,$xplot,$yplot,$bt,$et);
		$table_header[$col_num] = "<TD BGCOLOR=\"666666\" ALIGN=LEFT>Past ".get_date_pretty($graph_date)."</TD>\n";
		$table_data[$col_num] = "<TD>$graph_tag</TD>\n";
		$col_num++;
	}

	print "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	print "<TR><TD COLSPAN=$max_cols>$host_header</TD></TR>\n";
	$col_num = 0;
	$col_count = 0;
	$stat_num = 0;

	foreach($table_header as $k => $v) {
		if($col_num == 0) {
			print "<TR>\n";
		}
		print "$table_header[$k]\n";
		$col_num++;
		if($col_num >= $max_cols) {
			print "</TR>\n";
			$col_count = $stat_num - ($max_cols - 1 );
			print "<TR>\n";
			while($col_count <= $stat_num) {
				print $table_data[$col_count]."\n";
				$col_count++;
			}
			print "</TR>\n";
			$col_num = 0;
		}
		$stat_num++;
	}
	if($col_num != 0) {
		print "</TR>\n";
		$col_count = $stat_num - ($max_cols - 1 );
		print "<TR>\n";
		while($col_count <= $stat_num) {
			print $table_data[$col_count]."\n";
			$col_count++;
		}
		print "</TR>\n";
		$col_num = 0;
	}
	print "</TABLE>\n";
}

#
# display all id's in the listed class
#
function displayclass($dbc,$class,$host) {
	printheader("$class on $host");

	print "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	print "<TR>";
	print "<TH BGCOLOR=\"6699CC\"> </TH>\n";
	print "<TH ALIGN=LEFT BGCOLOR=\"666666\">$class stats for host $host</TH>";
	print "</A></TR>\n";
	$x = 0;

	
	$selectQuery="SELECT name from router where name LIKE '".preg_replace('/\*/','%',$host)."' ORDER BY name";
	$selectResult0 = query($dbc,$selectQuery);
	while($selectRow0=fetch_object($selectResult0)) {
		$this_host = $selectRow0->name;
		print "<!-- found host [$this_host] -->\n";

	$rid = getrid($dbc,$this_host);
	if($rid == -1) {
		print "ERROR: $this_host is not in the database\n";
	}

	$selectQuery="SHOW TABLES LIKE '%\\_$rid'";
	$selectResult=query($dbc,$selectQuery);
	$class_array = array();
	while ($selectRow=fetch_array($selectResult)){
		list($table_name,$foo) = split("_",$selectRow[0]);
		$selectQuery="SELECT * from mapping_table where tablename=\"$table_name\"";
		$selectResult2=query($dbc, $selectQuery);
		while ($selectRow2=fetch_object($selectResult2)) {
			$selectQuery="SELECT * from options_table where graphname=\"$selectRow2->graphname\" AND class=\"$class\"";
				$selectResult3=query($dbc,$selectQuery);
				$selectRow3 = fetch_object($selectResult3,$dbc);
				list($module_name,$foo) = split("-",$selectRow2->graphname);
				$class_array[$selectRow3->class][$module_name] = 1;
			}
	}

	if(!isset($class_array[$class])) { 
		continue; 
	}

	foreach($class_array[$class] as $module => $v) {
		if($x % 2 == 0) {
			$bgcolor="6699CC";
		}
		else { $bgcolor="CCFFFF"; }

		$html_string = stat_html_string($dbc,$this_host,$module,$class,$rid,$_SESSION["graph_date"]);
		if($html_string != "") {
			$split_host = preg_split('//',$this_host);
			$ver_host = "";
			foreach($split_host as $char) { 
				$ver_host .= "$char<BR>"; 
			}
			print "<TR><TD BGCOLOR=\"$bgcolor\"><FONT FACE=\"ARIAL\" SIZE=2 COLOR=\"black\">\n";
			print "<A HREF=\"".$_SERVER["SCRIPT_NAME"]."/host/$this_host\" COLOR=\"black\">$ver_host</A></TD>\n";
			print "<TD><!-- html_string start-->\n";
			print "$html_string\n";
			print "<!-- html_string insert end --></TD></TR>\n";
		}
	}
	$x++;
}
	print "</TABLE>\n";
}

function displayhost($dbc,$host) {
	printheader("$host");
	
	$rid = getrid($dbc,$host);
	if($rid == -1) {
		print "ERROR: $host is not in the database\n";
	}

	$selectQuery="SHOW TABLES LIKE '%\\_$rid'";
	$selectResult=query($dbc,$selectQuery);
	$class_array = array();
	while ($selectRow=fetch_array($selectResult)){
		list($table_name,$foo) = split("_",$selectRow[0]);
		$selectQuery="SELECT * from mapping_table where tablename=\"$table_name\"";
		$selectResult2=query($dbc, $selectQuery);
		while ($selectRow2=fetch_object($selectResult2)) {
			$selectQuery="SELECT * from options_table where graphname=\"$selectRow2->graphname\"";
				$selectResult3=query($dbc,$selectQuery);
				$selectRow3 = fetch_object($selectResult3,$dbc);
				list($module_name,$foo) = split("-",$selectRow2->graphname);
				$class_array[$selectRow3->class][$module_name] = 1;
			}
	}
	
	ksort($class_array);
	print "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	
	$header_array["Host:"] = $host;
	$header_array["sysDescr:"] = getsysDescr($dbc,$host);
	$host_header = print_host_header($header_array);

	print "<TR><TD>$host_header</TR></TD>\n";
	print "<TR><TD ALIGN=CENTER BGCOLOR=\"CCCCFF\">\n";
	foreach($class_array as $k => $v ) {
		print "<A HREF=\"".$_SERVER["SCRIPT_NAME"]."/stat/$k/$host\">[$k]</A>\n";
	}
	print "</TD></TR>\n";
	
	
	foreach($class_array as $k_array => $v_array) {
		foreach($v_array as $module => $v) {
	print "<!-- $k_array - $module - $v -->\n";
			# we need to get what will be graphed
			$html_string = stat_html_string($dbc,$host,$module,$k_array,$rid,$_SESSION["graph_date"]);


			if($html_string != "") {
				print "<TR>";
				print "<TH ALIGN=LEFT BGCOLOR=\"666666\"><A name=\"#$k_array\">$k_array stats</TH>";
				print "</A></TR>\n";
				print "<TR><TD><!-- html_string start-->\n";
				print "$html_string\n";
				print "<!-- html_string insert end --></TD></TR>\n";
			}
		}
	}
	print "</TABLE>\n";



}

#
# create html string to display graphs of stat
#
function stat_html_string($dbc,$host,$module,$class,$rid,$graph_len) {

	$max_cols = 2;
	$bgcolor = "999999";

	# make sure html_string is clean
	$html_string = "";

	$has_tables = get_table_list($dbc,$rid);

	$selectQuery="SELECT graphname from options_table where class=\"$class\" and graphname like \"$module%\"";
	$selectResult2=query($dbc,$selectQuery);
	while($selectRow2 = fetch_object($selectResult2)) {
		$selectQuery="SELECT tablename from mapping_table where graphname=\"$selectRow2->graphname\"";
		$selectResult=query($dbc,$selectQuery);
		while($selectRow = fetch_object($selectResult)) {
			$f_table = $selectRow->tablename;
			print "<!-- [$stat] $f_table -->\n";
			if(isset($has_tables[$f_table])) {
				print "<!-- yay! we found $f_table -->\n";
				$selectQuery="SELECT DISTINCT id from ".$f_table."_$rid  WHERE dtime > DATE_SUB(CURDATE(),INTERVAL 24 HOUR);";
				print "<!-- $selectQuery -->\n";
				$selectResult2=query($dbc,$selectQuery);
				while($selectRow2 = fetch_object($selectResult2)) {
					print "<!-- found valid iid of $selectRow2->id -->\n";
					$selectQuery="SELECT id, name, description FROM interface WHERE id=$selectRow2->id ORDER BY name";
					print "<!-- $selectQuery -->\n";
					$selectResult3=query($dbc, $selectQuery);
					while ($selectRow3=fetch_object($selectResult3)){
						print "<!-- blee $selectRow3->id -- $selectRow3->name -->\n";
						$iid_list[$selectRow3->id] = "$selectRow3->name ($selectRow3->description)";
					}
				}
			}
		}
	}

	#
	# if we didnt' find any iid's, we return nothing
	#
	if(!isset($iid_list)) { return ""; }
	ksort($iid_list);

	$et = time();
	$bt = $et - conv_our_time($graph_len);

	$time_range="dtime>FROM_UNIXTIME($bt) AND dtime<=FROM_UNIXTIME($et)";

	# have we figured out the graph size to use?
	$have_graph_size = 0;
	# have we checked to see if we compact interfaces
	# into the same table row?
	$check_compact = 0;
	# do we compact interfaces into the same table row?
	$compact_rows = 0;

	# used as a counter for id's in compacting rows
	$z = 0; 
	foreach($iid_list as $k => $v) {
		$num_graphs = 0;
		$selectQuery="SELECT description, name, speed FROM interface WHERE rid=$rid AND id=$k";
		$selectResult2=query($dbc, $selectQuery);
		$selectRow2=fetch_object($selectResult2);
		$interface_name = $selectRow2->name;
		$interface_description= $selectRow2->description;

		$stat_list = array();
		$options_list = array();
		$selectQuery="SELECT graphname,options from options_table where class=\"$class\" and graphname like \"$module%\"";
		$selectResult=query($dbc,$selectQuery);
		while($selectRow = fetch_object($selectResult)) {
			$found_table = 0;
			$selectQuery="SELECT tablename from mapping_table where graphname=\"$selectRow->graphname\"";
			$selectResult2=query($dbc,$selectQuery);
			while($selectRow2 = fetch_object($selectResult2)) {
				if($has_tables[$selectRow2->tablename]) {
					$found_table = 1;
				}
			}
			
			if($found_table > 0) {
				array_push($stat_list,$selectRow->graphname);
				$options_list[$selectRow->graphname] = $selectRow->options;
				$num_graphs++;
			}
		}

		# set the graph sizes so everything looks pretty and easy
		# to read as you scroll down a page
		if($have_graph_size == 0) {
			if($num_graphs > $max_cols) {
			print "<!-- num_graphs is $num_graphs -->\n";
				$max_cols = $num_graphs;
			}
			list($xplot,$yplot) = get_graph_size($max_cols);
			$have_graph_size = 1;
		}

		# do we compact rows to hvae more then one id?
		if($check_compact == 0) {
			if($num_graphs == 1) {
				$compact_rows = 1;
			}
			$check_compact = 1;
		}

		# only set the title rowif we'll be doing somethignin the foreach loop
		if(isset($stat_list[0])) {
			$table_header[$z] = "$interface_name ($interface_description) from $module\n";
			
		}
	
		$y = 0;
		foreach($stat_list as $lstat) {
			$table_data[$z][$y] = "<A HREF=\"".$_SERVER["SCRIPT_NAME"]."/stat/$lstat/$host/$k\">";
			$table_data[$z][$y] .= create_img_tag($dbc,$lstat,$rid,$k,$xplot,$yplot,$bt,$et);
			$table_data[$z][$y] .= "</A>\n";
			$y++;
		}
		$z++;
	}

	$html_string .= "<TABLE CELLPADDING=0 BORDER=0 CELLSPACING=0>\n";
	$html_string .= "<TR>\n";
	$col_num = 0;
	$stat_num = 0;
	if($compact_rows) {
		while(isset($table_header[$stat_num])) {
			if($col_num == 0) {
				$html_string .= "<TR>\n";
			}


			$html_string .= "<TD BGCOLOR=\"$bgcolor\" ALIGN=LEFT><I>$table_header[$stat_num]</I></TD>\n";

			$col_num++;
			if($col_num >= $max_cols) {
				$html_string .= "</TR>\n";
				$col_num = 0;
				# print out the stats for the col
				$col_count = $stat_num - ($max_cols - 1 );
				$html_string .= "<TR>\n";
				while($col_count <= $stat_num) {
					$html_string .= "<TD>".$table_data[$col_count][0]."</TD>\n";
					$col_count++;
				}
				$html_string .= "</TR>\n";
			} 

			$stat_num++;
		}

		# if col_num isn't zero, we didn't finish...
		if($col_num != 0) {
			$html_string .= "</TR>\n";
			$col_num = 0;
			# print out the stats for the col
			$col_count = $stat_num - ($max_cols - 1 );
			$html_string .= "<TR>\n";
			while($col_count <= $stat_num) {
				$html_string .= "<TD>".$table_data[$col_count][0]."</TD>\n";
				$col_count++;
			}
			$html_string .= "</TR>\n";
		}

		
		
	} else {
		$html_string .= "<TR>\n";
		foreach($table_header as $z => $th) {
			$html_string .= "<TD BGCOLOR=\"$bgcolor\" COLSPAN=$max_cols ALIGN=LEFT><I>$th</I></TD></TR>\n";
			$html_string .= "<TR>\n";
			foreach($table_data[$z] as $td) {
				$html_string .= "<TD>$td</TD>\n";
			}
			$html_string .= "</TR>\n";
		}
	} 
	
	$html_string .= "</TR>\n";


	
	$html_string .= "</TABLE>";

	return $html_string;
}

function create_img_tag($dbc,$stat,$rid,$iid,$xplot,$yplot,$bt,$et) {

	$img_string = "";
	$table_list = array();

	$has_tables = get_table_list($dbc,$rid);

	$options_list = array();
	$selectQuery="SELECT graphname,options from options_table where graphname=\"$stat\"";
	$selectResult=query($dbc,$selectQuery);
	while($selectRow = fetch_object($selectResult)) {
		$options_list[$selectRow->graphname] = $selectRow->options;
	}
	
	$time_range="dtime>FROM_UNIXTIME($bt) AND dtime<=FROM_UNIXTIME($et)";

	$selectQuery="SELECT tablename from mapping_table where graphname=\"$stat\"";
	$selectResult=query($dbc,$selectQuery);
	$x = 0;
	$args="";
	while($selectRow = fetch_object($selectResult)) {
		$f_table = $selectRow->tablename;
		if(isset($has_tables[$f_table])) {
			$selectQuery="SELECT id from ".$f_table."_$rid where id=$iid AND $time_range LIMIT 1";
			$selectResult2=query($dbc,$selectQuery);
			$selectRow2 = fetch_array($selectResult2);
			if(isset($selectRow2[0])) {
				$x++;
				$table_list["t$x"]=$f_table;
				echo "<!-- yay! we found $f_table for $stat -->\n";
				$args=$args."t$x=".$f_table."_$rid&";
			} else {
				echo "<!-- $f_table isn't valid for this interface! -->\n";
			}	
		}
	}	

	if($x > 0) {
		$args=$args."iid=$iid&xplot=$xplot&yplot=$yplot&";
		$graph_options = split(" ",$options_list[$stat]);
		foreach($graph_options as $g_opt) {
			$args=$args."$g_opt&";
		}
		$args = $args."begin=$bt&end=$et";
		echo "<!-- [$stat][$args] -->\n";
		$args = preg_replace("/%/","%25",$args);
		$rtgplot = $_SESSION["rtgplot"];
		$img_string = "<IMG SRC=$rtgplot?$args>";
	}


	return $img_string;
}


#
# get rid of host
#
function getrid($dbc,$host) {
	$selectQuery="SELECT rid from router where name=\"$host\"";
	$selectResult=query($dbc,$selectQuery);
	if($selectRow=fetch_array($selectResult)) {
		return $selectRow[0];
	} else {
		return -1;
	}
}
#
# get sysDescr
#
function getsysDescr($dbc,$host) {
	$rid=getrid($dbc,$host);
	$selectQuery="SELECT description from interface WHERE rid=\"$rid\" AND name=\"sysDescr\"";
	$selectResult=query($dbc,$selectQuery);
	$selectRow=fetch_object($selectResult);

	return $selectRow->description;
}

#
# return list of tables for the host
#
function get_table_list($dbc,$rid) {
	$has_table_list = array();
	$selectQuery="SHOW TABLES LIKE '%\\_$rid'";
	$selectResult=query($dbc, $selectQuery);
	while($selectRow = fetch_array($selectResult)) {
		list($table_name,$foo) = split("_",$selectRow[0]);
		$has_table_list[$table_name] = 1;
	}
	return $has_table_list;
}

#
# get seconds from our graph_len string
#
function conv_our_time($graph_len) {

	$time_mod = "";
	$time_format = substr($graph_len,-1);
        $time_num = substr($graph_len,0,-1);
        if($time_format == "h") {
		$time_mod = $time_num * 60 * 60;
	} elseif($time_format== "d") {
		$time_mod = $time_num * 24 * 60 * 60;
	} elseif($time_format == "w") {
		$time_mod = $time_num * 7 * 24 * 60 * 60;
	} elseif($time_format == "m") {
		$time_mod = $time_num * 30 * 7 * 24 * 60 * 60;
	} elseif($time_format == "y") {
		$time_mod = $time_num * 365 * 7 * 24 * 60 * 60;
	}
	else {
		$time_mod = $time_num;
	}
	
	return $time_mod;
}

?>
